#
#
# $Id: gtkthread.rb,v 1.23 2003/12/21 03:09:00 Yuukis Exp $
#
#

class ThreadFrame < Gtk::VPaned
	require 'nkf'

	attr_reader :post, :vadj_info, :vadj, :close, :prev, :next
	attr_reader :bookmark, :abone

	def initialize(board, dat, url)
		@id = {'board' => board, 'dat' => dat, 'url' => url }
		@bbs_thread ||= LiveBBSThread.new(board, dat)
		@vadj ||= Gtk::Adjustment.new(0, 0, 0, 0, 0, 0)
		@vadj_info ||= GtkExt::AdjInfo.new(board, dat, @vadj)

		@bookmark = @bbs_thread.bookmark
		@abone = @bbs_thread.abone

		vsb = Gtk::VScrollbar.new(@vadj)
		@text = Gtk::Text.new(nil, @vadj)
		@text.add_vikey_events(@vadj)
		@text.add_mousescroll_events(@vadj)

		@text.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::GDK_f
				refresh
			end
		}

		@text.signal_connect('button_press_event') {|w, e|
			case e.button
			when 3
				if @text.has_selection?
					target = get_selection
					target.gsub!(/[>]*/, '').strip!
					case target
					when /^[\d-]+/e
						x = @bbs_thread.get__N(NKF.nkf('-Z', target).to_i)
						if x != ''
							GtkExt::FollowPop.new(x).popup(nil, nil, nil, e.button, e.time)
						end
					when CFG::Regex.uri_2ch
						b = $3 ; d = $4
						b.sub(/(.+?)\/(\d+)/) { b = $1 ; d = $2 } if b =~ /\//
						r = @bbs_thread.get__1(b, d+'.dat')
						if r
							GtkExt::FollowPop.new(r).popup(nil, nil, nil, e.button, e.time)
						end
					end
				end
			end
		}

		get

		tbox = Gtk::HBox.new
		tbox.pack_start @text
		tbox.pack_start vsb, false

		super()
		set_usize(1, 1)
		self.add1(tbox)
		self.set_gutter_size(0)
		self.set_handle_size(0)
		self
	end

	def get
		th, @id['title'] = @bbs_thread.get
		th = CFG::NLS.moved_dat_hell.sub(/%url/, @id['url']) if th == false
		insert_thread(th)
	end

	def get_fup_num  # not yet. 1-20 ˤбǤ褦˳ĥͽꡣ
		n = ''
		@text.get_chars(0, @text.get_length).each {|x| n = x if x =~ CFG::Regex.id }
		n.sub!(/:.*/, '').chomp!
	end

	def update
		# no work.
	end

	def dat
		@id['dat']
	end

	def board
		@id['board']
	end

	def title
		@id['title']
	end

	def url
		@id['url']
	end

	def child
		@text
	end

	def adjust(value = false)
		value = @vadj_info.get unless value
		@vadj.set_value(value)
	end
	
	def get_selection(get_num = false)
		slct_start = @text.selection_start_pos
		slct_end = @text.selection_end_pos
		if slct_start > slct_end
			tmp = slct_start
			slct_start = slct_end
			slct_end = tmp
		end
		x = @text.get_chars(slct_start, slct_end).chomp
		if get_num
			num = ''
			@text.get_chars(0, slct_start).split("\n").reverse_each {|line|
				if line =~ CFG::Regex.head_id
					num = $1
					break
				end
			}
			return([x, num])
		else
			return(x)
		end
	end

	def label
		case CFG::UIF.tabbutton_type
		when 0
			label = Gtk::Label.new("#{String2ch.trunc(@id['title'])}")  # ܥ󤬤ʤẸ
			label.show_all
			return([label])
		when 1
			label = Gtk::Label.new("#{String2ch.trunc(@id['title'])} ")
			@close = Gtk::Button.new.add Pix.get('close')
			box = Gtk::HBox.new
			box.pack_start label
			box.pack_start @close, false
			box.show_all
			return([box, @close])
		else
			label = Gtk::Label.new("#{String2ch.trunc(@id['title'])} ")
			@close = Gtk::Button.new.add Pix.get('close')
			@next = Gtk::Button.new.add Pix.get('next')
			@prev = Gtk::Button.new.add Pix.get('prev')
			box = Gtk::HBox.new
			box.pack_start label
			box.pack_start @prev, false
			box.pack_start @close, false
			box.pack_start @next, false
			box.show_all
			return([box, @close, @prev, @next])
		end
	end

	def find(word)
		return if word == ''
		word.gsub!(/^:/, '') if MigemoExt::TYPE
		Logger.write(__FILE__, __LINE__, "word => #{word}") if $DEBUG
		Logger.write(__FILE__, __LINE__, "MigemoExt::TYPE => #{MigemoExt::TYPE}") if $DEBUG
		if @text.selection_start_pos == @text.selection_end_pos
			pos = 0
		else
			pos = @text.position + 2
		end
		str = @text.get_chars(0, @text.get_length)
		Logger.write(__FILE__, __LINE__, "Position => #{pos}") if $DEBUG
		Logger.write(__FILE__, __LINE__, "String Size => #{str.size}") if $DEBUG

		if MigemoExt::TYPE
			if str =~ MigemoExt.regex(word)
				word = $&
				result = str.jindex(word, pos)
				Logger.write(__FILE__, __LINE__, "Find Result => #{result}") if $DEBUG
			end
		else
			result = str.jindex(word, pos)
			Logger.write(__FILE__, __LINE__, "Find Result => #{result}") if $DEBUG
		end

		if result
			@text.adjustment_switch(@vadj, result)
			@text.select_region(result, result + word.euclength)
		end
	end

	def increment(word)
		return if word !~ /^:/
		word.gsub!(/^:/, '')
		return if word == ''
		pos = 0
		str = @text.get_chars(0, @text.get_length)
		if str =~ MigemoExt.regex(word)
			x = $&
			result = str.jindex(x, pos)
			@text.adjustment_switch(@vadj, result)
			@text.select_region(result, result + x.euclength)
		end
	end

	def insert_thread(stream)
		@text.freeze
		quote = CFG::GDK_Color.thread_quote_fg
		stream.each {|line|  # from goRua. Thanks.
			line.chomp!
			if line !~ CFG::Regex.quote
				base = CFG::GDK_Color.thread_base_fg
			else
				base = quote
			end
			while true
				case line
				when CFG::Regex.id  # إå
					line.gsub!(/<\/b>/, '')
					line.gsub!(/<b>/, '')
					@text.insert nil, CFG::GDK_Color.thread_header_fg, nil, line 
					break
				when CFG::Regex.follow_many  # FollowUpMany
					@text.insert nil, base, nil, $1
					@text.insert nil, CFG::GDK_Color.thread_followup_fg, nil, $2
					line = $3
				when CFG::Regex.follow  # FollowUp
					@text.insert nil, base, nil, $1
					@text.insert nil, CFG::GDK_Color.thread_followup_fg, nil, $2
					line = $3
				when CFG::Regex.uri  # URL
					@text.insert nil, base, nil, $1
					@text.insert nil, CFG::GDK_Color.thread_uri_fg, nil, $2
					line = $3
				else
					@text.insert nil, base, nil, line
					break
				end
			end
			@text.insert nil, base, nil, "\n"
		}
		@text.thaw
	end

	def delete_thread
		@text.freeze
		@text.delete_text(0, @text.get_length)
		@text.thaw
	end
	private :delete_thread

	def refresh
		@bbs_thread.refresh
		delete_thread
		get
	end

	def redraw
		self.set_gutter_size(0)
		self.set_handle_size(0)
		self.set_position(5000)
	end
end


class LiveThreadFrame < ThreadFrame

	attr_reader :post, :mode

	def initialize(board, dat, url)
		super
		@mode = 'live'

		child.signal_connect('key_press_event'){|w, e|
			case e.keyval
			when Gdk::GDK_e
				@post.quote_button.clicked
			end
		}

		post_init
		add2 @post
	end

	def update(reget = false)
		@bbs_thread.get(reget)
		th = @bbs_thread.get_cache__N(get_fup_num + '-')
		insert_thread(th)
	end

	def reget
		update(true)
	end

	def post_init
		@post = BBSPostBox.new(@id['board'], @id['dat'], @id['title'])

		@post.cancel_button.signal_connect('clicked') {
			unless @post.posting
				post_close
				GtkExt.parent_window(child).set_focus(child)
				if @post.post?
					update
					@post.post?(true)
				end
			end
		}

		@post.quote_button.signal_connect('clicked') {
			str , num = get_selection(true)
			@post.insert_reply(str, num)
		}
	end

	def post_open
		if child.has_selection?
			str, num = get_selection(true)
			@post.show_all(str, num)
		else
			@post.show_all
		end
		self.set_gutter_size(CFG::UIF.postbox_border + 2)
		self.set_handle_size(CFG::UIF.postbox_border)
		self.set_position(CFG::UIF.height - CFG::UIF.postbox_height)
	end

	def redraw
		super
		@post.clear
	end

	alias post_close redraw
end


class PastThreadFrame < ThreadFrame

	PAST = 'past'

	attr_reader :mode

	def initialize(board, dat, url)
		@bbs_thread = PastBBSThread.new(board, dat)
		@vadj = Gtk::Adjustment.new(0, 0, 0, 0, 0, 0)
		@vadj_info = GtkExt::AdjInfo.new(board, dat, @vadj, PAST)

		super
		@mode = 'past'

		add2 Gtk::Label.new('')
	end
end
